<?php
require_once 'vendor/autoload.php';

use Appwrite\Client;

// You can remove imports of services you don't use

// ini_set('display_errors', 1);
// ini_set('display_startup_errors', 1);
// error_reporting(E_ALL);

/*
  '$req' variable has:
    'headers' - object with request headers
    'payload' - request body data as a string
    'variables' - object with function variables

  '$res' variable has:
    'send(text, status)' - function to return text response. Status code defaults to 200
    'json(obj, status)' - function to return JSON response. Status code defaults to 200

  If an error is thrown, a response with code 500 will be returned.
*/

include 'register_server.php';
include 'redirect_code.php';

return function($req, $res) {
  $client = new Client();

  if(!$req['variables']['APPWRITE_FUNCTION_ENDPOINT'] || !$req['variables']['APPWRITE_FUNCTION_API_KEY']) {
    echo('Environment variables are not set. Function cannot use Appwrite SDK.');
    exit;
  }

  $client
    ->setEndpoint($req['variables']['APPWRITE_FUNCTION_ENDPOINT'])
    ->setProject($req['variables']['APPWRITE_FUNCTION_PROJECT_ID'])
    ->setKey($req['variables']['APPWRITE_FUNCTION_API_KEY'])
    ->setSelfSigned(true);

  $input = trim($req['payload']);

  $input = json_decode($input);

  if($input->action == 'register_server') {
    $response = \mastodon_servers\register_server($input, $client, $req);

    $res->json($response);

    return;
  }

  if($input->action == 'redirect_code') {
    $response = \mastodon_servers\redirect_code($input, $client, $req);

    $res->json($response);

    return;
  }

  $res->json([
    'error' => 'No action!'
  ]);
};