<?php
namespace mastodon_servers;

require_once 'vendor/autoload.php';

use Appwrite\Client;

// You can remove imports of services you don't use
use Appwrite\Services\Account;
use Appwrite\Services\Databases;
use Appwrite\Services\Users;
use Appwrite\Query;

// class Mastodon_Servers {
    function redirect_code($input, $client, $req) {
        $account = new Account($client);
        $database = new Databases($client);
        $users = new Users($client);
        
        $query = new Query();

        $user = $users->getPrefs($input->user_id);

        $responseBody = $database->listDocuments(
            $req['variables']['APPWRITE_DATABASE_ID'], 'servers', [ 
                $query->equal("server_url", $user['user_server_uri'], )
            ]
        )['documents'][0];

        $request = new \GuzzleHttp\Client(['base_uri' => $user['user_server_uri']]);

        try {
            $response = $request->request('POST', "/oauth/token", [
                'form_params' => [
                    'client_id' => $responseBody['client_id'],
                    'client_secret' => $responseBody['client_secret'],
                    'redirect_uri' =>  $req['variables']['BASE_URI'] . '/redirect.php?user_id=' . $input->user_id,
                    'grant_type' => 'authorization_code',
                    'code' => $input->code,
                    'scope' => 'read write',
                ]
            ]);

            $responseBody = (string)$response->getBody();
            $responseBody = json_decode($responseBody);

            $user['user_token'] = $responseBody->access_token;

            $users->updatePrefs($input->user_id, $user);

            try {
                $response = $request->request('GET', "/api/v1/accounts/verify_credentials", [
                    'headers' => [
                        'Authorization' => 'Bearer ' . $user['user_token']
                    ]
                ]);

                $responseBody = (string)$response->getBody();
                // $responseBody = json_decode($responseBody);

                $user['account_details'] = $responseBody;

                $users->updatePrefs($input->user_id, $user);

                return [
                    'status' => 'success',
                ];    

            } catch (\GuzzleHttp\Exception\ClientException $e) {
                return [
                    'status' => 'failed',
                    'reason' => 'token not vaild'
                ];
            }
        } catch (\GuzzleHttp\Exception\ClientException $e) {
            return [
                'status' => 'failed',
                'error' => $e->getMessage()
            ];
        }
    }
// }