<?php

namespace mastodon_servers;

require_once 'vendor/autoload.php';

use Appwrite\Client;

// You can remove imports of services you don't use
use Appwrite\Services\Account;
use Appwrite\Services\Databases;
use Appwrite\Services\Users;
use Appwrite\Query;

// class Mastodon_Servers
// {
    function register_server($input, $client, $req)
    {
        $account = new Account($client);
        $database = new Databases($client);
        $users = new Users($client);

        $query = new Query;

        $server_query = $query->equal('server_url', $input->server_url);

        $server_details = $database->listDocuments($req['variables']['APPWRITE_DATABASE_ID'], 'servers', [$query->equal("server_url", $input->server_url),]);

        // return [
        //     'status' => 'success',
        //     'response' => $server_details
        // ];

        $responseBody = '';

        if ($server_details['total'] == 0) {
            $request = new \GuzzleHttp\Client(['base_uri' => $input->server_url]);

            try {
                $response = $request->request('POST', "/api/v1/apps", [
                    'form_params' => [
                        'client_name' => 'Mastodon Algorithm (Dev)',
                        'redirect_uris' => $req['variables']['BASE_URI'] . '/redirect.php',
                        'scopes' => 'read write',
                        'website' => $req['variables']['BASE_URI']
                    ]
                ]);

                $createAppBody = (string)$response->getBody();
                $createAppBody = json_decode($createAppBody);

                $record = $database->createDocument($req['variables']['APPWRITE_DATABASE_ID'], 'servers', 'unique()', [
                    'server_url' => $input->server_url,
                    'client_id' => $createAppBody->client_id,
                    'client_secret' => $createAppBody->client_secret
                ]);

                // return [
                //     'status' => 'success',
                //     'response' => $createAppBody
                // ];

                // try {
                //     $response = $request->request('POST', "/oauth/token", [
                //         'form_params' => [
                //             'client_id' => $createAppBody->client_id,
                //             'client_secret' => $createAppBody->client_secret,
                //             'redirect_uri' => $req['variables']['BASE_URI'] . '/redirect.php',
                //             'grant_type' => 'client_credentials'
                //         ]
                //     ]);

                //     $createAppTokenBody = (string)$response->getBody();
                //     $createAppTokenBody = json_decode($createAppTokenBody);

                //     $record = $database->updateDocument($req['variables']['APPWRITE_DATABASE_ID'], 'servers', $record['$id'], [
                //         'app_access_token' => $createAppTokenBody->access_token
                //     ]);

                //     $responseBody = $createAppTokenBody;
                // } catch (\GuzzleHttp\Exception\ClientException $e) {
                //     return [
                //         'status' => 'failed',
                //         'error' => 'Failed to validate app',
                //         'response' => $e->getMessage()
                //     ];
                // }
            } catch (\GuzzleHttp\Exception\ClientException $e) {
                return [
                    'status' => 'failed',
                    'error' => 'Failed to create app',
                    'response' => $e->getMessage()
                ];
            }

            // var_dump($record);

            // var_dump($responseBody);      
        }

        $responseBody = $database->listDocuments($req['variables']['APPWRITE_DATABASE_ID'], 'servers', [$query->equal("server_url", $input->server_url),])['documents'][0];

        $users->updatePrefs($input->user_id, [
            'user_server_uri' => $input->server_url
        ]);

        $redirect_uri = $input->server_url . "/oauth/authorize?client_id=" . $responseBody['client_id'] . "&scope=read+write&redirect_uri=" . $req['variables']['BASE_URI'] . '/redirect.php?user_id=' . $input->user_id . '&response_type=code';

        return [
            'status' => 'success',
            'redirect_uri' => $redirect_uri,
            'server_url' => $input->server_url
        ];
    }
// }