<?php

require_once 'vendor/autoload.php';

use Appwrite\Client;

// You can remove imports of services you don't use
use Appwrite\Services\Account;
// use Appwrite\Services\Avatars;
use Appwrite\Services\Databases;
// use Appwrite\Services\Functions;
// use Appwrite\Services\Health;
// use Appwrite\Services\Locale;
// use Appwrite\Services\Storage;
// use Appwrite\Services\Teams;
use Appwrite\Services\Users;
use Appwrite\Query;

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

/*
  '$req' variable has:
    'headers' - object with request headers
    'payload' - request body data as a string
    'variables' - object with function variables

  '$res' variable has:
    'send(text, status)' - function to return text response. Status code defaults to 200
    'json(obj, status)' - function to return JSON response. Status code defaults to 200

  If an error is thrown, a response with code 500 will be returned.
*/

return function($req, $res) {
  $client = new Client();

  // You can remove services you don't use
  $account = new Account($client);
  // $avatars = new Avatars($client);
  $database = new Databases($client);
  // $functions = new Functions($client);
  // $health = new Health($client);
  // $locale = new Locale($client);
  // $storage = new Storage($client);
  // $teams = new Teams($client);
  $users = new Users($client);

  $query = new Appwrite\Query;

  if(!$req['variables']['APPWRITE_FUNCTION_ENDPOINT'] || !$req['variables']['APPWRITE_FUNCTION_API_KEY']) {
    echo('Environment variables are not set. Function cannot use Appwrite SDK.');
    exit;
  }

  $client
    ->setEndpoint($req['variables']['APPWRITE_FUNCTION_ENDPOINT'])
    ->setProject($req['variables']['APPWRITE_FUNCTION_PROJECT_ID'])
    ->setKey($req['variables']['APPWRITE_FUNCTION_API_KEY'])
    ->setSelfSigned(true);

  $input = trim($req['payload']);

  $input = json_decode($input);

  // $server_query = $query->equal('server_url', $input->server_url);

  // $server_details = $database->listDocuments('637fd77aae471453b595', 'servers', [ $query->equal("server_url", $input->server_url), ]);

  // $responseBody = '';

  // if($server_details['total'] == 0) {
  //   $request = new GuzzleHttp\Client(['base_uri' => $input->server_url]);

  //   $response = $request->request('POST', "/api/v1/apps", [
  //     'form_params' => [
  //       'client_name' => 'Mastodon Algorithm (Dev)',
  //       'redirect_uris' => $req['variables']['BASE_URI'] . '/redirect.php',
  //       'scopes' => 'read write',
  //       'website' => $req['variables']['BASE_URI']
  //     ]
  //   ]);

  //   $responseBody = (string)$response->getBody();
  //   $responseBody = json_decode($responseBody);

    $record = $database->createDocument('637fd77aae471453b595', 'servers', 'ID.unique()', [
      'server_url' => 'https://test.com',
      'client_id' => 'test',
      'client_secret' => 'testing'
    ]);

    var_dump($record);

    // var_dump($responseBody);

    // $response = $request->request('POST', "/oauth/token", [
    //   'form_params' => [
    //     'client_id' => $responseBody['client_id'],
    //     'client_secret' => $responseBody['client_secret'],
    //     'redirect_uri' => $req['variables']['BASE_URI'] . '/redirect.php',
    //     'grant_type' => 'client_credentials'
    //   ]
    // ]);


  // }

  $res->json([
    'areDevelopersAwesome' => true,
    // 'error' => json_last_error_msg()
    'server_url' => $input->server_url,
    'servers' => $server_details,
    'createAppResponse' => $responseBody,
    'query' => $query->equal("server_url", $input->server_url)
  ]);

  // var_dump(json_decode(mb_convert_encoding($req['payload'], "UTF-8")));

};